# --------------------------------------------------------------------------
# Access Mechanism 
# --------------------------------------------------------------------------

The EqualLogic storage module uses the EqualLogic Python and PSAPIs to interact with the EqualLogic storage device.

# --------------------------------------------------------------------------
#  Supported Functionality
# --------------------------------------------------------------------------

	- Clone volume

# -------------------------------------------------------------------------
# Functionality Description
# -------------------------------------------------------------------------
  1. Clone volume

     The clone method clones the existing volume as per the parameters specified in the definition. 

# -------------------------------------------------------------------------
# Summary of parameters
# -------------------------------------------------------------------------

    name - This parameter defines the name of the new cloned volume.

	ensure - (Required) This parameter is required to call the create or destroy method.
    The possible values are: "present" or "absent".
    If the ensure parameter is set to "present", the module calls the create method.
    If the ensure parameter is set to "absent", the module calls the destroy method.

	volume_name – This parameter defines the name of the volume, which will be cloned.

# -------------------------------------------------------------------------
# Parameter signature 
# -------------------------------------------------------------------------

#Provide transport and volume properties

	define equallogic::vol_clone (
		$ensure        = 'present',
		$volume_name   = 'eqClone'
  
	) {

		equallogic_volume_clone { "${name}":
			ensure        => $ensure,
			volume_name   => $volume_name,  
		}
	}

# --------------------------------------------------------------------------
# Usage
# --------------------------------------------------------------------------
   Refer to the examples in the manifest directory.
   The following file contains the details for the sample init.pp and supported files:

    - vol_clone.pp
	
   Sample init.pp file:-
   
   class equallogic {
		equallogic::vol_clone { 'demoAnupClone1001':
			ensure              =>  absent
			volume_name   		=> 'demoAnup'
		}
	}

   You can create an init.pp file based on the above samples and run the "puppet device" command , for example: 
   # puppet device

#-------------------------------------------------------------------------------------------------------------------------
# End
#-------------------------------------------------------------------------------------------------------------------------	
