# --------------------------------------------------------------------------
# Access Mechanism 
# --------------------------------------------------------------------------

The EqualLogic storage module uses the EqualLogic Python and PSAPIs to interact with the EqualLogic storage device.

# --------------------------------------------------------------------------
#  Supported Functionality
# --------------------------------------------------------------------------

	- Get volume IQN

# -------------------------------------------------------------------------
# Functionality Description
# -------------------------------------------------------------------------


  1. Get volume IQN

     This method displays the available volume's IQN as per the parameters specified in the definition. 

# -------------------------------------------------------------------------
# Summary of parameters
# -------------------------------------------------------------------------

    name - This parameter defines the name of the volume.

	ensure - (Required) This parameter is required to call the create or destroy method.
              The possible values are: "present" or "absent".
    If ensure parameter is set to "present", the module calls the create method.
    If ensure parameter is set to "absent", the module calls the destroy method.

    username - This parameter defines login username for the device. 
	password - This parameter defines the password for the device.
	host - This parameter defines the IP address of the device.

# -------------------------------------------------------------------------
# Parameter signature 
# -------------------------------------------------------------------------

#Provide transport and volume properties

	define equallogic::vol_get_iqn (
		$ipaddress,
		$username,
		$password,
		$ensure = present
	) {
		equallogic_volume_get_iqn { "${name}":
			ipaddress         => $ipaddress,
			username          => $username,
			password          => $password,
			ensure            => $ensure
		}
	}

# --------------------------------------------------------------------------
# Usage
# --------------------------------------------------------------------------
   Refer to the examples in the manifest directory.
   The following file contains the details for the sample init.pp and supported files:

    - vol_get_iqn.pp
	
   Sample init.pp file:
   
   class equallogic {
		equallogic::vol_get_iqn { 'demoOne':
			ipaddress 		=> '172.16.100.70',
			username  		=> 'grpadmin',
			password  		=> 'grpadmin',
			ensure       	=> absent,
		}
	}

 You can create an init.pp file based on the above samples and run the "puppet device" command , for example: 
   # puppet device

#-------------------------------------------------------------------------------------------------------------------------
# End
#-------------------------------------------------------------------------------------------------------------------------	
