# --------------------------------------------------------------------------
# Access Mechanism 
# --------------------------------------------------------------------------

The EqualLogic storage module uses the EqualLogic Python API to interact with the EqualLogic storage device.

# --------------------------------------------------------------------------
#  Supported Functionality
# --------------------------------------------------------------------------

	-Volume multi-host access enable
	-Volume multi-host access disable
	
# -------------------------------------------------------------------------
# Functionality Description
# -------------------------------------------------------------------------
	
	1. Volume multi-host access enable
	
		This method enables the multi-host access of given volume.


	2. Volume multi-host access disable
		
		This method disables the multi-host access of given volume.
		
		
# -------------------------------------------------------------------------
# Summary of parameters
# -------------------------------------------------------------------------
	name - This parameter defines the name of the volume.

	ensure - (Required) This parameter is required to call the create or destroy method.
             The possible values are: "present" or "absent".
    If ensure parameter is set to "present", the module calls the create method.
    If ensure parameter is set to "absent", the module calls the destroy method.

    username - This parameter defines login username for the device. 
	password - This parameter defines the password for the device.
	host -  This parameter defines the IP address of the device.
	multihostaccess - This parameter sets the multi-host access for the volume {enable | disable}.
			
# -------------------------------------------------------------------------
# Parameter signature 
# -------------------------------------------------------------------------

#Provide transport and volume properties

	define equallogic::vol_multi_host_access (
		$ensure = 'absent',
		$ipaddress,
		$username,
		 $password,
		 $multihostaccess
		) {

		  equallogic_volume { "${name}":
			ensure            => $ensure,
			ipaddress         => $ipaddress,
			username          => $username,
			password          => $password,
			multihostaccess => $multihostaccess,
		}
	}
	
	
# --------------------------------------------------------------------------
# Usage
# --------------------------------------------------------------------------
   Refer to the examples in the manifest directory.
   The following files contains the details for the sample init.pp and supported files:
   
		- vol_state_change.pp
		
   Sample init.pp file:
	
	class equallogic {
		equallogic::vol_multi_host_access {'eqClone123':
		ipaddress 			=> '172.16.100.70',
		username  			=> 'grpadmin',
		password  			=> 'grpadmin',
		ensure              =>  present,
		multihostaccess 	=> 'disable'
		}
	}
  
   
   You can create an init.pp file based on the above sample files and run the "puppet device" command , for example: 
   # puppet device


#-------------------------------------------------------------------------------------------------------------------------
# End
#-------------------------------------------------------------------------------------------------------------------------	
