# --------------------------------------------------------------------------
# Access Mechanism 
# --------------------------------------------------------------------------

The EqualLogic storage module uses the EqualLogic Python API to interact with the EqualLogic storage device.

# --------------------------------------------------------------------------
#  Supported Functionality
# --------------------------------------------------------------------------

	- Volume online
	- Volume offline
	
# -------------------------------------------------------------------------
# Functionality Description
# -------------------------------------------------------------------------
	
	1. Volume online
	
		This method gets a given volume to online state.

	2. Volume offline
		
		This method gets a given volume to offline state.
				
# -------------------------------------------------------------------------
# Summary of parameters
# -------------------------------------------------------------------------
	name - This parameter defines the name of the volume.

	ensure - (Required) This parameter is required to call the create or destroy method.
			 The possible values are: "present" or "absent".
    If ensure parameter is set to "present", the module calls the create method.
    If ensure parameter is set to "absent", the module calls the destroy method.

    username - This parameter defines login username for the device. 
	password - This parameter defines the password for the device.
	host - This parameter defines the IP address of the device.
	state - This parameter sets the status for the volume {online | offline}.
			
# -------------------------------------------------------------------------
# Parameter signature 
# -------------------------------------------------------------------------

#Provide transport and volume properties

	define equallogic::vol_state (
		 $ensure,
		 $ipaddress,
		 $username,
		 $password,
		 $state
		) {
		equallogic_volume { "${name}":
			ensure            => $ensure,
			ipaddress         => $ipaddress,
			username          => $username,
			password          => $password,
			state             => $state,
		}
	}
		
# --------------------------------------------------------------------------
# Usage
# --------------------------------------------------------------------------
   Refer to the examples in the manifest directory.
   The following file contains the details for the sample init.pp and supported files:

    - vol_state.pp
   
   Sample init.pp file:
	
	class equallogic {
		equallogic::vol_multi_host_access {'eqClone123':
		ipaddress 			=> '172.16.100.70',
		username  			=> 'grpadmin',
		password  			=> 'grpadmin',
		ensure              =>  present,
		state 				=> 'online'
		}
	}
	
   You can create an init.pp file based on the above sample files and run the "puppet device" command , for example: 
   # puppet device

#-------------------------------------------------------------------------------------------------------------------------
# End
#-------------------------------------------------------------------------------------------------------------------------	
