import sys
from pysnmp.entity.rfc3413.oneliner import cmdgen

groupIPAddress = sys.argv[1]
snmpCommunityString = sys.argv[2]
command = sys.argv[3]

cmdGen = cmdgen.CommandGenerator()

def getVolumesInUse():
	volumesInUse = ""
	errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(
		cmdgen.CommunityData(snmpCommunityString),
		cmdgen.UdpTransportTarget((groupIPAddress, 161)),
		(1,3,6,1,4,1,12740,1,1,2,1,8,1)
	)

        if errorStatus:
		print "Failed to fetch the volumes in use from SNMP MIB"
		return volumesInUse

	if errorIndication:
        	print(errorIndication)
        	return volumesInUse

	for oid, val in varBinds: 
		volumesInUse = val
        print volumesInUse
	return volumesInUse

def getSnapshotsInUse():
        snapsInUse = ""
        errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(
                cmdgen.CommunityData(snmpCommunityString),
                cmdgen.UdpTransportTarget((groupIPAddress, 161)),
                (1,3,6,1,4,1,12740,1,1,2,1,7,1)
        )

        if errorStatus:
                print "Failed to fetch the snapshots in use from SNMP MIB"
                return snapsInUse

        if errorIndication:
                print(errorIndication)
                return snapsInUse

        for oid, val in varBinds:
                snapsInUse = val
        print snapsInUse
        return snapsInUse

def getSnapshotReserve():
        snapReserve = ""
        errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(
                cmdgen.CommunityData(snmpCommunityString),
                cmdgen.UdpTransportTarget((groupIPAddress, 161)),
                (1,3,6,1,4,1,12740,1,1,2,1,25,1)
        )

        if errorStatus:
                print "Failed to fetch the snapshot reserve from SNMP MIB"
                return snapReserve

        if errorIndication:
                print(errorIndication)
                return snapReserve

        for oid, val in varBinds:
                snapReserve = val
        print snapReserve
        return snapReserve

def getReplicationReserve():
        replReserve = ""
        errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(
                cmdgen.CommunityData(snmpCommunityString),
                cmdgen.UdpTransportTarget((groupIPAddress, 161)),
                (1,3,6,1,4,1,12740,1,1,2,1,26,1)
        )

        if errorStatus:
                print "Failed to fetch the replication reserve from SNMP MIB"
                return replReserve

        if errorIndication:
                print(errorIndication)
                return replReserve

        for oid, val in varBinds:
                replReserve = val
        print replReserve
        return replReserve

def getDelegated():
        delegated = ""
        errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(
                cmdgen.CommunityData(snmpCommunityString),
                cmdgen.UdpTransportTarget((groupIPAddress, 161)),
                (1,3,6,1,4,1,12740,1,1,2,1,17,1)
        )

        if errorStatus:
                print "Failed to fetch the delegated from SNMP MIB"
                return delegated

        if errorIndication:
                print(errorIndication)
                return delegated

        for oid, val in varBinds:
                delegated = val
        print delegated
        return delegated

def getFreeSpace():
        freeSpace = ""
        errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(
                cmdgen.CommunityData(snmpCommunityString),
                cmdgen.UdpTransportTarget((groupIPAddress, 161)),
                (1,3,6,1,4,1,12740,1,1,2,1,15,1)
        )

        if errorStatus:
                print "Failed to fetch the free space from SNMP MIB"
                return freeSpace

        if errorIndication:
                print(errorIndication)
                return freeSpace

        for oid, val in varBinds:
                freeSpace = val
        print freeSpace
        return freeSpace

def getVolumeReserve():
        volReserve = ""
        errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(
                cmdgen.CommunityData(snmpCommunityString),
                cmdgen.UdpTransportTarget((groupIPAddress, 161)),
                (1,3,6,1,4,1,12740,1,1,2,1,2,1)
        )

        if errorStatus:
                print "Failed to fetch the volume reserve from SNMP MIB"
                return volReserve

        if errorIndication:
                print(errorIndication)
                return volReserve

        for oid, val in varBinds:
                volReserve = val
        print volReserve
        return volReserve


if command == "getvolumeinuse":
        getVolumesInUse()

if command == "getsnapshotinuse":
        getSnapshotsInUse()

if command == "getsnapshotreserve":
        getSnapshotReserve()

if command == "getreplicationreserve":
        getReplicationReserve()

if command == "getdelegated":
        getDelegated()

if command == "getfreespace":
        getFreeSpace()

if command == "getvolumereserve":
        getVolumeReserve()

