#!/usr/bin/env python

"""Python Equallogic program that uses eqlscript.py

Copyright (C) 2013-2014 by Dell, Inc.

All rights reserved.  This software may not be copied, disclosed, 
transferred, or used except in accordance with a license granted 
by Dell, Inc.  This software embodies proprietary information 
and trade secrets of Dell, Inc. 
"""

import eqlscript
import sys
import re
import time

def show():
	global output, err, errmsg
	output = session.cmd("cli-settings formatoutput on")
	err = session.err()
	if err:
		errmsg = "Failed to Show.\n"
		return
	
	output = session.cmd ("show")
	err = session.err()
	if err:
		errmsg = "Failed to Show"	
	return

def MemberShowForDiscovery():
	global output, err, errmsg	
	memberName = args[0]

	output = session.cmd("cli-settings formatoutput off")
	err = session.err()
	if err:
		errmsg = "Failed to Show.\n"
		return

	cmd = "member show "
	if ( memberName != "" ):
		cmd = cmd + memberName

	output = session.cmd(cmd)
	err = session.err()
	if err:
		errmsg = "Failed to Show.\n"
	return


def GroupParamsShowDiscovery():
	global output, err, errmsg
	output = session.cmd("cli-settings formatoutput off")
	err = session.err()
	if err:
		errmsg = "Failed to Show.\n"
		return

	output = session.cmd("grpparams show")
	err = session.err()
	if err:
		errmsg = "Failed to Show GroupParams.\n"
	return


def VolumeSetIsnsDiscovery():
	global output, err, errmsg

	volName = args[0]
	isnsDiscovery = args[1]
	output = session.cmd("volume select " + volName + " isns-discovery " + isnsDiscovery)
	err = session.err()
	if err:
		errmsg = "Failed to '" + isnsDiscovery + "' isns-discovery for Volume '" + volName + "'.\n"
	return

	
def PoolShow():
	global output, err, errmsg
	poolName = args[0]
	if poolName == "":
		output = session.cmd("pool show")
	else:
		output = session.cmd("pool sel " + poolName + " show")
	err = session.err()
	if err:
		errmsg = "Failed to show pool information."
	return

def ShowPoolVolumeInfo():
	global output, err, errmsg
	volName = args[0]

	output = session.cmd("cli-settings paging off")
	err = session.err()
	if err:
		errmsg = "Error \n"
		return

	output = session.cmd("cli-settings formatoutput off")
	err = session.err()
	if err:
		errmsg = "Error \n"
		return

	output = session.cmd("show -poolinfo volume " + volName)
	err = session.err()
	if err:
		errmsg = "Error \n"

	return

def MemberInfoShow():
	global output, err, errmsg
	memberName = args[0]
	
	output = session.cmd("member sel " + memberName + " show")
	err = session.err()
	if err:
		errmsg = "Error in showing Member Info.\n"
	return

def VolumeCollectionInfoShow():
        global output, err, errmsg
        
        output = session.cmd("collection show")
        err = session.err()
        if err:
                errmsg = "Error in showing collection Info.\n"
        return

def SnapCollectionInfoShow():
        global output, err, errmsg

        output = session.cmd("snapcol show")
        err = session.err()
        if err:
                errmsg = "Error in showing collection Info.\n"
        return


def SystemInfoShow():
	global output, err, errmsg
	memberName = args[0]
	
	output = session.cmd("member sel " + memberName + " eth show")
	err = session.err()
	if err:
		errmsg = "Error in showing System Info.\n"
	return


def EthInfo():
	global output, err, errmsg
	interfaceName = args[0]
	memberName = args[1]
	
	output = session.cmd("cli-settings formatoutput off")
	err = session.err()
	if err:
		errmsg = "Failed to Show.\n"
		return
		
	output = session.cmd("member sel " + memberName + " eth select " + interfaceName + " show")
	err = session.err()
	if err:
		errmsg = "Failed to show.\n"
	return


def MemberShow():
	global output, err, errmsg
	memberName = args[0]
	cmd = "member show"
	if memberName != "":
	    cmd = cmd + " " + memberName

	output = session.cmd(cmd)
	err = session.err()
	if err:
		errmsg = "Failed to Show.\n"
	return


def MemberPoolInfo():
	global output, err, errmsg
	output = session.cmd("member show -poolinfo")
	err = session.err()
	if err:
		errmsg = "Failed to Show.\n"
	return


def GroupParamsShow():
	global output, err, errmsg
	output = session.cmd("grpparams show")
	err = session.err()
	if err:
		errmsg = "Failed to Show GroupParams.\n"
	return


def CreateVolume():
	global output, err, errmsg
	volName = args[0]
	volSize = args[1]
	volstate = args[2]
	poolName = args[3]
	snapReserve = args[4]
	thinProvision = args[5]
	thinMinReserve = args[6]
	thinGrowthWarn = args[7]
	thinGrowthMax = args[8]
	thinWarnSoftThres = args[9]
	thinWarnHardThres = args[10]
	cmd = "vol create " + volName + " " + volSize
	if volstate != "":
		cmd = cmd + " " + volstate
	if poolName != "":
		cmd = cmd + " pool " + poolName
	if snapReserve != "":
		cmd = cmd + " snap-reserve " + snapReserve
	if thinProvision == "enable":
		cmd = cmd + " thin-provision"
	if thinMinReserve != "" and thinProvision == "enable":
		cmd = cmd + " thin-min-reserve " + thinMinReserve
	if thinGrowthWarn != "" and thinProvision == "enable":
		cmd = cmd + " thin-growth-warn " + thinGrowthWarn
	if thinGrowthMax != "" and thinProvision == "enable":
		cmd = cmd + " thin-growth-max " + thinGrowthMax
	if thinWarnSoftThres == "enable":
		cmd = cmd + " thin-warn-soft-threshold " + thinWarnSoftThres
	if thinWarnHardThres == "enable":
		cmd = cmd + " thin-warn-hard-threshold " + thinWarnHardThres
	print cmd
	output = session.cmd(cmd)
	err = session.err()
	if err:
		errmsg = "Failed to create volume " + volName + " size " + volSize + ".\n"
	return


def VolumeShow():
	global output, err, errmsg
	volName = args[0]
	if volName == "":
		output = session.cmd("vol show")
		err = session.err()
		if err:
			errmsg = "Failed to show volume information.\n"
			return
	else:
		output = session.cmd("vol show " + volName)
		err = session.err()
		if err:
			errmsg = "Failed"

	return


			
def VolumeDelete():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("vol delete " + volName)
	err = session.err()
	if err:
		errmsg = "Failed to delete volume " + volName + ".\n"

	return


def VolumeOffline():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("vol sel " + volName + " offline")
	err = session.err()
	if err:
		errmsg = "Failed to Offline Volume '" + volName + "'."

def VolumeOnline():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("vol sel " + volName + " online")
	err = session.err()
	if err:
		errmsg = "Failed to online volume '" + volName + "'.\n"

	return

def VolumeShare():
	global output, err, errmsg
	volName = args[0]
	multiAccess = args[1]
	output = session.cmd("vol sel " + volName + "  multihost-access " + multiAccess)
	err = session.err()
	if err:
		errmsg = "Failed to enable sharing for '" + volName + "'.\n"

	return

def VolumeClone():
	global output, err, errmsg
	volName = args[0]
	cloneName = args[1]
	output = session.cmd("vol sel " + volName + " clone " + cloneName)
	err = session.err()
	if err:
		errmsg = "Cloning for '" + cloneName + "' is Failed.\n"

	return

def VolumeThinProvision():
	global output, err, errmsg
	volName = args[0]
	thinProvision = args[1]
	output = session.cmd("vol sel " + volName + " thin-provision " + thinProvision)
	err = session.err()
	if err:
		errmsg = "Error '" + thinProvision + "' thinProvision on '" + volName + "'.\n"

	return

def VolumeAccessCreate():
	global output, err, errmsg
	volName = args[0]
	initiatorOrIp = args[1]
	if re.match("iqn", initiatorOrIp, re.I | re.M):
		cmd = "vol sel " + volName + " access create initiator " + initiatorOrIp
	else:
		cmd = "vol sel " + volName + " access create ipaddress " + initiatorOrIp
		
	output = session.cmd(cmd)
	err = session.err()
	if err:
		errmsg = "Error creating access.\n"

	return

def VolumeAccessShow():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("vol sel " + volName + " access show")
	err = session.err()
	if err:
		errmsg = "Error in showing access for Volume '" + volName + "'.\n"

	return

def VolumeAccessRestrict():
	global output, err, errmsg
	volName = args[0]
	accessID = args[1]
	applyTo = args[2]
	output = session.cmd("vol sel " + volName + " access sel " + accessID + " apply-to " + applyTo)
	err = session.err()
	if err:
		errmsg = "Error in restricting Access '" + accessID + "' to '" + applyTo + "'.\n"

	return	


def VolumeAccessDelete():
	global output, err, errmsg
	volName = args[0]
	accessID = args[1]
	output = session.cmd("vol sel " + volName + " access del " + accessID)
	err = session.err()
	if err:
		errmsg = "Error in deleting Access '" + accessID + "' for Volume '" + volName + "'.\n"

	return


def SystemInterfaceInfo():
	global output, err, errmsg
	memberName = args[0]
	interfaceNumber = args[1]
	name = "eth" + interfaceNumber
	output = session.cmd("member sel " + memberName + " eth select " + interfaceNumber + " show")
	err = session.err()
	if err:
		errmsg = "Error in showing Interface Info for '" + name + "' for '" + memberName + "'.\n"

	return


def PoolCreate():
	global output, err, errmsg
	poolName = args[0]
	description = args[1]
	cmd ="pool create " + poolName
	if description != "":
	    cmd = cmd + " description '" + description + "'"
	
	output = session.cmd(cmd)
	err = session.err()
	if err:
		errmsg = "Error Creating pool '" + poolName + "'.\n"

	return

def PoolDelete():
	global output, err, errmsg
	poolName = args[0]
	output = session.cmd("pool delete " + poolName)
	err = session.err()
	if err:
		errmsg = "Error Deleting pool " + poolName + ". \n"

	return

def PoolRename():
	global output, err, errmsg
	poolName = args[0]
	newPoolName = args[1]
	output = session.cmd("pool rename " + poolName + "  " + newPoolName)
	err = session.err()
	if err:
		errmsg = "Error renaming pool '" + poolName + "' to '" + newPoolName + "'.\n"

	return

def PoolAddMember():
	global output, err, errmsg
	poolName = args[0]
	memberName = args[1]
	output = session.cmd("member sel " + memberName + " pool " + poolName)
	err = session.err()
	if err:
		errmsg = "Error adding Member '" + memberName + "' to Pool '" + poolName + "'. \n"

	return

def GroupPerformanceBalance():
	global output, err, errmsg
	perfBalancing = args[0]
	if perfBalancing != "enable" and perfBalancing != "disable":
	    print "Error:Performance Balance may have the value enable | disable.\n"
	    return
	output = session.cmd("grpparams perf-balancing " + perfBalancing)
	err = session.err()
	if err:
		errmsg = "Error Adjusting Performance Balance on Group.\n"

	return

def ShowPoolMemberInfo():
	global output, err, errmsg
	memberName = args[0]
	errmsg = "Error \n"
	output = session.cmd("cli-settings paging off")
	err = session.err()
	if err:
		return
	output = session.cmd("cli-settings formatoutput on")
	err = session.err()
	if err:
		return
	output = session.cmd("show -poolinfo member " + memberName)
	err = session.err()

	return


def ReplicationCreate ():
	global output, err, errmsg
	volName = args[0]
	repPartnerName = args[1]
	output = session.cmd("volume sel " + volName + " replication enable " + repPartnerName + " local-rep-reserve 200% keep-failback")
	err = session.err()
	if err:
		errmsg = "Failed to enable replication of " + volName
		return

	print output

	output = session.cmd("volume sel " + volName + " replication create-replica partnerName")
	err = session.err()
	if err:
		errmsg = "Failed to create replica of " + volName
		return

	print output

	output = session.cmd("volume sel " + volName + " replication show")
	err = session.err()
	if err:
		errmsg = "Failed to show replication in progress"
		return

	print output
	
	wait = 30
	complete = False
	while complete == False and wait > 0:
		print a
		if re.match("/" + repPartnerName + "\s\d+\sready/", a):
			print "replication done"
			complete = True
		else:
			print "replication is in progress...\n"
		time.sleep(5)
		wait = wait - 1

	return

def ReplicationScheduleCreate ():
	global output, err, errmsg
	volName = args[0]
	repPartnerName = args[1]
	interval = args[2]
	startDate = args[3]
	endDate = args[4]
	startTime = args[5]
	endTime = args[6]
	frequency = args[7]
	maxKeep = args[8]
	repeatInterval = args[9]
	scheduleName = args[10]

	output = session.cmd("volume sel " + volName + " schedule create " + scheduleName + " type " + interval + 
		" start-date " + startDate + " end-date " + endDate + " start-time " + startTime + " end-time " + endTime + 
		" frequency " + frequency + " max-keep " + maxKeep + " partner " + repPartnerName + " repeat-interval " + repeatInterval)
	err = session.err()
	if err:
		errmsg = "Failed to create replication Schedule of " + volName
	return


def ReplicationScheduleDelete ():
	global output, err, errmsg
	volName = args[0]
	scheduleName = args[1]
	output = session.cmd("volume sel " + volName + " schedule delete " + scheduleName)
	err = session.err()
	if err:
		errmsg = "Failed to delete Replication Schedule of " + volName
	return


def ReplicationCancel ():
	global output, err, errmsg
	volName = args[0]
	repPartnerName = args[1]
	output = session.cmd("volume sel " + volName + " replication cancel " + repPartnerName)
	err = session.err()
	if err:
		errmsg = "Failed to cancel Replication of " + volName
	return


def ReplicationDemote ():
	global output, err, errmsg
	volName = args[0]
	repPartnerName = args[1]
	output = session.cmd("volume sel " + volName + " replication demote " + repPartnerName)
	err = session.err()
	if err:
		errmsg = "Failed to Demote " + volName
	return


def ReplicationDisable ():
	global output, err, errmsg
	volName = args[0]
	repPartnerName = args[1]
	output = session.cmd("volume sel " + volName + " replication disable " + repPartnerName)
	err = session.err()
	if err:
		errmsg = "Failed to Disable Replication of " + volName
	return


def ReplicationPause ():
	global output, err, errmsg
	volName = args[0]
	repPartnerName = args[1]
	output = session.cmd("volume sel " + volName + " replication pause " + repPartnerName)
	err = session.err()
	if err:
		errmsg = "Failed to Pause Replication of " + volName
	return


def ReplicationResume ():
	global output, err, errmsg
	volName = args[0]
	repPartnerName = args[1]
	output = session.cmd("volume sel " + volName + " replication resume " + repPartnerName)
	err = session.err()
	if err:
		errmsg = "Failed to Resume Replication of " + volName
	return


def ReplicationShow ():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("volume sel " + volName + " replication show")
	err = session.err()
	if err:
		errmsg = "Failed to show Replication"
	return


def ReplicationScheduleRename ():
	global output, err, errmsg
	volName = args[0]
	scheduleName = args[1]
	newScheduleName = args[2]
	output = session.cmd("volume sel " + volName + " schedule rename " + scheduleName + " " + newScheduleName)
	err = session.err()
	if err:
		errmsg = "Failed to Rename Replication Schedule of " + volName + ""
	return


def ReplicationScheduleShow ():
	global output, err, errmsg
	volName = args[0]
	scheduleName = args[1]
	output = session.cmd("volume sel " + volName + " schedule show " + scheduleName)
	err = session.err()
	if err:
		errmsg = "Failed to Show Replication Schedule of " + volName
	return


def SnapshotCreate ():
	global output, err, errmsg
	volName = args[0]
	snapshotStatus = args[1]
	snapshotPermission = args[2]
	snapshotDescription = args[3]
	cmd = "volume sel " + volName + " snapshot create-now"
	if snapshotStatus != "":
		cmd = cmd + " " + snapshotStatus
	if snapshotPermission != "":
		cmd = cmd + " " + snapshotPermission
	if snapshotDescription != "":
		cmd = cmd + " description '" + snapshotDescription + "'"

	output = session.cmd(cmd)
	err = session.err()
	if err:
		errmsg = "Failed to Create the Snapshot.\n"
	return

def SnapshotSetIsnsDiscovery():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	isnsDiscovery = args[2]

	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " isns-discovery " + isnsDiscovery)
	err = session.err()
	if err:
		errmsg = "Failed to set isns-discovery to '" + isnsDiscovery + "'.\n"
	return


def SnapshotRename ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	newSnapshotName = args[2]
	output = session.cmd("volume sel " + volName + " snapshot rename " + snapshotName + " " + newSnapshotName)
	err = session.err()
	if err:
		errmsg = "Failed to rename the Snapshot '" + snapshotName + "'.\n"
	return

	
def SnapshotShow ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	if snapshotName != "":
		output = session.cmd("volume sel " + volName + " snapshot show " + snapshotName)
		err = session.err()
		if err:
			errmsg = "Failed to Show Snapshot '" + snapshotName + "'.\n"
			return
	else:
		output = session.cmd("volume sel " + volName + " snapshot show")
		err = session.err()
		if err:
			errmsg = "Failed to show the Snapshot(s).\n"
	return


def SnapshotDelete ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	output = session.cmd("volume sel " + volName + " snapshot delete " + snapshotName)
	err = session.err()
	if err:
		errmsg = "Failed to Delete Snapshot '" + snapshotName + "'.\n"
	return


def SnapshotCloneCreate ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	cloneVolumeName = args[2]
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " clone " + cloneVolumeName)
	err = session.err()
	if err:
		errmsg = "Failed to Create the Clone from Snapshot '" + snapshotName + "'.\n"
	return


def SnapshotSetMultiHostAccess ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	multiHostAccess = args[2]
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " multihost-access " + multiHostAccess)
	err = session.err()
	if err:
		errmsg = "Failed to '" + multiHostAccess + "' multi-host-access for Snapshot '" + snapshotName + "'.\n"
	return


def SnapshotSetStatus ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	snapshotStatus = args[2]
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " " + snapshotStatus)
	err = session.err()
	if err:
		errmsg = "Failed to '" + snapshotStatus + "' Snapshot '" + snapshotName + "'.\n"
	return


def SnapshotSetRWPermission ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	snapshotPermission = args[2]
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " " + snapshotPermission)
	err = session.err()
	if err:
		errmsg = "Failed to set '" + snapshotName + "' RW Permission '" + snapshotPermission + "'.\n"
	return


def SnapshotSetIscsiAlias ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	iSCSIAlias = args[2]
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " iscsi-alias " + iSCSIAlias)
	err = session.err()
	if err:
		errmsg = "Failed to set iscsi-alias to '" + iSCSIAlias + "'.\n"
	return


def SnapshotSetDescription ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	snapshotDescription = args[2]
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " description '" + snapshotDescription + "'")
	err = session.err()
	if err:
		errmsg = "Failed to set description to '" + snapshotDescription + "'.\n"
	return


def SnapshotSetActionForLostBlocks ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]
	lostBlockAction = args[2]
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " lost-blocks " + lostBlockAction)
	err = session.err()
	if err:
		errmsg = "Failed to set lost-blocks action to '" + lostBlockAction + "'.\n"
	return


def SnapshotRestore ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]	
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " restore")
	err = session.err()
	if err:
		errmsg = "Failed to Restore from Snapshot '" + snapshotName + "'.\n"
	return


def SnapshotShowConnections ():
	global output, err, errmsg
	volName = args[0]
	snapshotName = args[1]	
	output = session.cmd("volume sel " + volName + " snapshot sel " + snapshotName + " show connections")
	err = session.err()
	if err:
		errmsg = "Failed to show Connections for Snapshot '" + snapshotName + "'.\n"
	return


def RaidPolicyConfigure ():
	global output, err, errmsg
	memberName = args[0]
	raidType = args[1]
	output = session.cmd("member sel " + memberName + " raid-policy " +  raidType) 
	err = session.err()
	if err:
		errmsg = "Error in Configuring raid-policy.\n"
	return


def AssignIpToInterface ():
	global output, err, errmsg
	interfaceName = args[0]
	interfaceIP = args[1]
	interfaceNetmask = args[2]
	memberName = args[3]
	temp = "eth" + interfaceName
	output = session.cmd("member sel " + memberName + " eth select " + interfaceName + " ipaddress " + interfaceIP + " netmask " + interfaceNetmask)
	err = session.err()
	if err:
		errmsg = "Failed to Assign IP '" + interfaceIP + "' to Interface '" + temp + "' on '" + memberName + "'	.\n "
	return


def UnAssignIPFromInterface ():
	global output, err, errmsg
	interfaceName = args[0]
	memberName = args[1]
	output = session.cmd("member sel " + memberName +" eth select " + interfaceName + " ipaddress none")  
	err = session.err()
	if err:
		errmsg = "Failed to Unassign Ip from Interface '" + interfaceName + "'.\n"
	return


def InterfaceStatusChange ():
	global output, err, errmsg
	interfaceName = args[0]
	interfaceStatus = args[1]
	memberName = args[2]
	temp = "eth" + interfaceName
	output = session.cmd("member sel " + memberName + " eth select " + interfaceName + " " + interfaceStatus) 
	err = session.err()
	if err:
		errmsg = "Failed to '" + interfaceStatus +"' Interface '" + temp + "'.\n"
	return


def VolumeShrink ():
	global output, err, errmsg
	volName = args[0]
	volSize = args[1]
	output = session.cmd("volume sel " + volName +" shrink " + volSize) 
	err = session.err()
	if err:
		errmsg = "Failed to shirk the Volume '" + volName +"' to '" + volSize+ "'.\n"
	return	


def VolumeGrow ():
	global output, err, errmsg
	volName = args[0]
	volSize = args[1]
	output = session.cmd("volume sel " + volName + " size " + volSize) 
	err = session.err()
	if err:
		errmsg = "Failed to Increase the size of the Volume '" +  volName+ "' to '" +  volSize + "'.\n"
	return	


def VolumeShowConnections ():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("volume sel " + volName + " show connections") 
	err = session.err()
	if err:
		errmsg = "Failed to show Connections for Volume '" +  volName + "'.\n"
	return	


def SetFormatOutput ():
	global output, err, errmsg
	formatOutput = args[0]
	output = session.cmd("cli-settings formatoutput " + formatOutput) 
	err = session.err()
	if err:
		errmsg = "Failed to set format Output.\n"
	return	


def GetFormatOutput ():
	global output, err, errmsg
	output = session.cmd("cli-settings show")  
	err = session.err()
	if err:
		errmsg = "Failed to Show cli-settings.\n"
	return	


def VolumeCancelOperation ():
	global output, err, errmsg
	volName = args[0]
	operationId = args[1]
	output = session.cmd("volume select " + volName + " cancel-operation " + operationId)  
	err = session.err()
	if err:
		errmsg = "Failed to cancel Operation Operation ID '" +  operationId + "'.\n"
	return	


def VolumeConvert ():
	global output, err, errmsg
	volName = args[0]
	convertTo = args[1]
	output = session.cmd("volume select " + volName + " convert-to " + convertTo) 
	err = session.err()
	if err:
		errmsg =  "Failed to convert Volume '" +  volName+ " to '" +  convertTo + "'.\n"
	return	


def VolumeThinCloneCreate ():
	global output, err, errmsg
	volName = args[0]
	thinCloneName = args[1]
	output = session.cmd("volume select " + volName + " create-thin-clone " +  thinCloneName) 
	err = session.err()
	if err:
		errmsg = "Failed to create Thin Clone '" +  thinCloneName + "'.\n"
	return	


def VolumeDeleteFailback ():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("volume select " + volName + " delete-failback " + volName) 
	err = session.err()
	if err:
		errmsg = "Failed to delete-failback Volume '" +  volName + "'.\n"
	return	


def VolumeDetachThinClone ():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("volume select " + volName + " detach-thin-clone") 
	err = session.err()
	if err:
		errmsg = "Failed to detach-thin-clone Volume '" +  volName + "'.\n"
	return	


def VolumeSetIscsiAlias ():
	global output, err, errmsg
	volName = args[0]
	iSCSIAlias = args[1]
	output = session.cmd("volume select " + volName + " iscsi-alias " + iSCSIAlias)  
	err = session.err()
	if err:
		errmsg = "Failed set the Volume '" +  volName + " iscsi-alias '" +  iSCSIAlias + "'.\n"
	return	


def VolumePool ():
	global output, err, errmsg
	volName = args[0]
	poolName = args[1]
	output = session.cmd("volume select " + volName +" pool " + poolName) 
	err = session.err()
	if err:
		errmsg = "Failed to change to Pool '" +  poolName+ " for Volume '" +  volName + "'.\n"
	return	


def VolumePrefRaidPolicy ():
	global output, err, errmsg
	volName = args[0]
	prefRaidPolicy = args[1]
	output = session.cmd("volume select " + volName + " pref-raid-policy " + prefRaidPolicy)  
	err = session.err()
	if err:
		errmsg = "Failed to set pref-raid-policy to '" +  prefRaidPolicy+ "' on Volume '" +  volName + "'.\n"
	return	


def VolumeSetRWPermission ():
	global output, err, errmsg
	volName = args[0]
	volumePermission = args[1]
	output = session.cmd("volume select " + volName + " " + volumePermission)  
	err = session.err()
	if err:
		errmsg = "Failed to set RW Permissions to '" +  volumePermission+ "' on Volume '" +  volName + "'.\n"
	return	


def VolumeSetDescription ():
	global output, err, errmsg
	volName = args[0]
	volumeDescription = args[1]
	output = session.cmd("volume select " + volName + " description '" +  volumeDescription + "'")  
	err = session.err()
	if err:
		errmsg = "Failed to set Description '" +  volumeDescription+ "' to Volume '" +  volName + "'.\n"
	return	 


def VolumeSetActionForLostBlocks ():
	global output, err, errmsg
	volName = args[0]
	lostBlockAction = args[1]
	output = session.cmd("volume sel " + volName + " lost-blocks " +lostBlockAction)  
	err = session.err()
	if err:
		errmsg = "Failed to set lost-blocks action to '" +  lostBlockAction + "'.\n"
	return	


def VolumeAssign ():
	global output, err, errmsg
	volName = args[0]
	volumeAdminName = args[1]
	output = session.cmd("volume select " + volName + " assign "+ volumeAdminName)  
	err = session.err()
	if err:
		errmsg = "Failed to Assign Volume '" +  volName+ "' to '" +  volumeAdminName + "'.\n"
	return	 


def VolumeBind ():
	global output, err, errmsg
	volName = args[0]
	groupMemberName = args[1]
	output = session.cmd("volume select " + volName + " bind " + groupMemberName)  
	err = session.err()
	if err:
		errmsg = "Failed to Bind Volume '" +  volName+ "' to Member '" +  groupMemberName + "'.\n"
	return	 


def VolumeUnAssign ():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("volume select " + volName + " unassign ")  
	err = session.err()
	if err:
		errmsg = "Failed to UnAssign Volume '" +  volName + "'.\n"
	return	 


def VolumeUnBind ():
	global output, err, errmsg
	volName = args[0]
	output = session.cmd("volume select " + volName + " unbind")  
	err = session.err()
	if err:
		errmsg = "Failed to UnBind Volume '" +  volName + "'.\n"
	return	 


def DCBSetDefaultVlan ():
	global output, err, errmsg
	vlanId= args[0]
	output = session.cmd("grpparams dcb def-vlan-id " + vlanId)  
	err = session.err()
	if err:
		errmsg = "Failed to Set the default vLanId '" +  vlanId + "'.\n"
	return	 


def AccountShow ():
	global output, err, errmsg
	userAccountName = args[0]
	if userAccountName != "":
		output = session.cmd("account show " + userAccountName)  
		err = session.err()
		if err:
			errmsg = "Failed to Show Account '" +  userAccountName+ " Information .\n"
	else:
		output = session.cmd("account show")  
		err = session.err()
		if err:
			errmsg = "Failed to show Accounts.\n"
	return	 



def VolumeMemberShow ():
	global output, err, errmsg
	volName= args[0]
	output = session.cmd("volume select " + volName + " show members")  
	err = session.err()
	if err:
		errmsg = "Failed to Show Volume '" +  volName + "' Members.\n"
	return	 


def VolumeSetSnapWarn ():
	global output, err, errmsg
	volName = args[0]
	snapWarn = args[1]
	output = session.cmd("volume select " + volName + " snap-warn " + snapWarn)  
	err = session.err()
	if err:
		errmsg = "Failed to Set snap-warn '" +  snapWarn + "'.\n"
	return	 


def VolumeSetSnapDepletion ():
	global output, err, errmsg
	volName = args[0]
	snapDepletion = args[1]
	output = session.cmd("volume select " + volName + " snap-depletion " + snapDepletion)  
	err = session.err()
	if err:
		errmsg = "Failed to Set snap-depletion '" +  snapDepletion + "'.\n"
	return	 


def VolumeSetSnapReserve ():
	global output, err, errmsg
	volName= args[0]
	snapReserve= args[1]
	output = session.cmd("volume select " + volName + " snap-reserve " + snapReserve)  
	err = session.err()
	if err:
		errmsg = "Failed to Set snap-reserve '" +  snapReserve + "'.\n"
	return	 


def DCBSetState ():
	global output, err, errmsg
	dcbState = args[0]
	output = session.cmd("grpparams dcb " + dcbState) 
	err = session.err()
	if err:
		errmsg =  "Failed to Set DCB '" +  dcbState + "'.\n"
	return


def ChapUserCreate ():
	global output, err, errmsg
	chapUserName= args[0]
	chapUserPassword= args[1]
	chapUserStatus= args[2]
	cmd = "chapuser create " + chapUserName 
	if chapUserStatus != "":
		cmd = cmd + " " + chapUserStatus
	
	if chapUserPassword != "":
	    cmd = cmd + " password " + chapUserPassword
	output = session.cmd(cmd)  
	
	err = session.err()
	if err:
		errmsg = "Failed to Create Chap User '" +  chapUserName + "'.\n"
	return	

def ChapUserDelete ():
	global output, err, errmsg
	chapUserName= args[0]
	output = session.cmd("chapuser delete " + chapUserName)  
	err = session.err()
	if err:
		errmsg = "Failed to Delete Chap User '" +  chapUserName +  "'.\n"
	return


def VolumeAccessEnableChapAuthentication ():
	global output, err, errmsg
	volName = args[0]
	accessID = args[1]
	output = session.cmd("volume select " + volName + " access select " + accessID + " authmethod chap")  
	err = session.err()
	if err:
		errmsg = "Failed to Enable Chap Authentication for Access '" +  accessID+ "' of Volume '" +  volName + "'.\n"
	return


def VolumeAccessDisableChapAuthentication ():
	global output, err, errmsg
	volName= args[0]
	accessID= args[1]
	output = session.cmd("volume select " + volName + " access select " + accessID + " authmethod none")  
	err = session.err()
	if err:
		errmsg = "Failed to Disable Chap Authentication for Access '" +  accessID+ "' of Volume '" +  volName + "'.\n"
	return


def VolumeAccessAssociateChapUser ():
	global output, err, errmsg
	volName= args[0]
	chapUserName= args[1]
	applyTo= args[2]
	cmd = "volume select " + volName + " access create username " + chapUserName + " authmethod chap"
	if applyTo != "":
		cmd = cmd + " apply-to " + applyTo
	output = session.cmd(cmd)  
	err = session.err()
	if err:
		errmsg = "Failed to Associate Chap User '" +  chapUserName+ "' with Volume '" +  volName + "'.\n"
	return


def ChapUserGetStatus ():
	global output, err, errmsg
	chapUserName= args[0]
	output = session.cmd("chapuser show " + chapUserName)  
	err = session.err()
	if err:
		errmsg = "Failed to Show Chap User '" +  chapUserName + "'.\n"
	return


def ChapUserSetState():
	global output, err, errmsg
	chapUserName = args[0]
	chapUserState = args[1]	
	output = session.cmd("chapuser select " + chapUserName + " " + chapUserState)
	err = session.err()
	if err:
		errmsg = "Failed to chapUserState Chap User '" + chapUserName + "' \n"
	return	
	

### Main program execution starts here...

# Since we are not using flags to denote input parameters, 
# assuming the invocation maintains the order :
#	pythonEqualogic.py <group> <user> <password> <command-name> args...
group = sys.argv[1]
user = sys.argv[2]
pwd = sys.argv[3]
cmd = sys.argv[4]
args = sys.argv[5:]

# put empty values in rest of the args to avoid multiple if checks later
# since max number of arguments needed is '11'
for x in range (len(args), 11):
	args.append("")

# Set default values
debug = False # Debug flag
# use telnet if this flag is True else use ssh by default.
telnet = False
errmsg = ""
err = ""
output = ""

eqlscript.DEBUG = debug
eqlscript.TIMEOUT = 100


# Create the session and log in
try:
	session = eqlscript.session (group, user, pwd, telnet)
except eqlscript.ConnectError:
	print "Error connecting to group address", group
	sys.exit(1)
except eqlscript.LoginError:
	print "Error logging in to username", user
	sys.exit(1)

# Invoke commands accordingly
if cmd == "show":
	show()

elif cmd == "discoverygrpparamsshow":
	GroupParamsShowDiscovery()

elif cmd == "snapshotsetisnsdiscovery":
	SnapshotSetIsnsDiscovery()

elif cmd == "volumesetisnsdiscovery":
	VolumeSetIsnsDiscovery()

elif cmd == "membershowfordiscovery":
	MemberShowForDiscovery()
	
elif cmd == "poolshow":
	PoolShow()

elif cmd == "poolvolumeinfo":
	ShowPoolVolumeInfo()

elif cmd == "memberinfoshow":
	MemberInfoShow()

elif cmd == "volumecollectioninfoshow":
	VolumeCollectionInfoShow()

elif cmd == "snapcollectioninfoshow":
	SnapCollectionInfoShow()

elif cmd == "systeminfoshow":
	SystemInfoShow()

elif cmd == "ethinfo":
	EthInfo()


elif cmd == "grpparamsshow":
	GroupParamsShow()

elif cmd == "volumecreate":
	CreateVolume()

elif cmd == "volumeshow":
	VolumeShow()
	
elif cmd == "volumedelete":
	VolumeDelete()

elif cmd == "volumeonline":
	VolumeOnline()

elif cmd == "volumeoffline":
	VolumeOffline()

elif cmd == "volumeshare":
	VolumeShare()

elif cmd == "volumeclone":
	VolumeClone()

elif cmd == "volumethinprovision":
	VolumeThinProvision()

elif cmd == "volumeaccesscreate":
	VolumeAccessCreate()

elif cmd == "volumeaccessshow":
	VolumeAccessShow()

elif cmd == "volumeaccessrestrict":
	VolumeAccessRestrict()

elif cmd == "volumeaccessdelete":
	VolumeAccessDelete()

elif cmd == "systeminterfaceinfo":
	SystemInterfaceInfo()

elif cmd == "poolcreate":
	PoolCreate()

elif cmd == "pooldelete":
	PoolDelete()

elif cmd == "poolrename":
	PoolRename()

elif cmd == "pooladdmember":
	PoolAddMember()

elif cmd == "memberpoolinfo":
	MemberPoolInfo()

elif cmd == "groupperfbalance":
	GroupPerformanceBalance()

elif cmd == "poolmemberinfo":
	ShowPoolMemberInfo()

elif cmd == "raidpolicyconfigure":
	RaidPolicyConfigure()

elif cmd == "membershow":
	MemberShow()

elif cmd == "assigniptointerface":
	AssignIpToInterface()

elif cmd == "unassignipfromnterface":
	UnAssignIPFromInterface()

elif cmd == "interfacestatuschange":
	InterfaceStatusChange()

elif cmd == "snapshotcreate":
	SnapshotCreate()

elif cmd == "snapshotdelete":
	SnapshotDelete()

elif cmd == "snapshotrename":
	SnapshotRename()

elif cmd == "snapshotshow":
	SnapshotShow()

elif cmd == "snapshotclonecreate":
	SnapshotCloneCreate()

elif cmd == "snapshotsetmultihostaccess":
	SnapshotSetMultiHostAccess()

elif cmd == "snapshotsetstatus":
	SnapshotSetStatus()

elif cmd == "snapshotsetrwpermission":
	SnapshotSetRWPermission()

elif cmd == "snapshotsetiscsialias":
	SnapshotSetIscsiAlias()

elif cmd == "snapshotsetdescription":
	SnapshotSetDescription()

elif cmd == "snapshotsetactionforlostblocks":
	SnapshotSetActionForLostBlocks()

elif cmd == "snapshotrestore":
	SnapshotRestore()

elif cmd == "snapshotshowconnections":
	SnapshotShowConnections	()

elif cmd == "volumegrow":
	VolumeGrow()

elif cmd == "volumeshrink":
	VolumeShrink()

elif cmd == "volumeshowconnections":
	VolumeShowConnections()

elif cmd == "replicationcreate":
	ReplicationCreate()

elif cmd == "replicationschedulecreate":
	ReplicationScheduleCreate()

elif cmd == "replicationscheduledelete":
	ReplicationScheduleDelete()

elif cmd == "replicationcancel":
	ReplicationCancel()

elif cmd == "replicationdemote":
	ReplicationDemote()

elif cmd == "replicationdisable":
	ReplicationDisable()

elif cmd == "replicationpause":
	ReplicationPause()

elif cmd == "replicationresume":
	ReplicationResume()

elif cmd == "replicationshow":
	ReplicationShow()

elif cmd == "replicationschedulerename":
	ReplicationScheduleRename()

elif cmd == "replicationscheduleshow":
	ReplicationScheduleShow()

elif cmd == "getformatoutput":
	GetFormatOutput()

elif cmd == "setformatoutput":
	SetFormatOutput()

elif cmd == "volumecanceloperation":
	VolumeCancelOperation()

elif cmd == "volumeconvert":
	VolumeConvert()

elif cmd == "volumethinclonecreate":
	VolumeThinCloneCreate()

elif cmd == "volumedeletefailback":
	VolumeDeleteFailback()

elif cmd == "volumedetachthinclone":
	VolumeDetachThinClone()

elif cmd == "volumesetiscsialias":
	VolumeSetIscsiAlias()

elif cmd == "volumepool":
	VolumePool()

elif cmd == "volumeprefraidpolicy":
	VolumePrefRaidPolicy()

elif cmd == "volumesetrwpermission":
	VolumeSetRWPermission()

elif cmd == "volumesetdescription":
	VolumeSetDescription()

elif cmd == "volumeassign":
	VolumeAssign()

elif cmd == "volumebind":
	VolumeBind()

elif cmd == "volumeunassign":
	VolumeUnAssign()

elif cmd == "volumeunbind":
	VolumeUnBind()

elif cmd == "dcbsetdefaultvlan":
	DCBSetDefaultVlan()

elif cmd == "accountshow":
	AccountShow()

elif cmd == "volumemembershow":
	VolumeMemberShow()

elif cmd == "volumesetsnapwarn":
	VolumeSetSnapWarn()

elif cmd == "volumesetsnapdepletion":
	VolumeSetSnapDepletion()

elif cmd == "volumesetsnapreserve":
	VolumeSetSnapReserve()

elif cmd == "dcbsetstate":
	DCBSetState()

elif cmd == "chapusercreate":
	ChapUserCreate()

elif cmd == "chapuserdelete":
	ChapUserDelete()

elif cmd == "volumeaccessenablechapauthentication":
	VolumeAccessEnableChapAuthentication()

elif cmd == "volumeaccessdisablechapauthentication":
	VolumeAccessDisableChapAuthentication()

elif cmd == "volumeaccessassociatechapuser":
	VolumeAccessAssociateChapUser()

elif cmd == "volumesetactionforlostblocks":
	VolumeSetActionForLostBlocks()

elif cmd == "chapusergetstatus":
	ChapUserGetStatus()

elif cmd == "chapusersetstate":
	ChapUserSetState()

# if everything else fails just execute the input command
else:
	cmds = cmd + " " + str( " ".join (args) )
	if debug:
		print "Executing command : ", cmds
	output = session.cmd(cmds)
	err = session.err()		


# Print output/error
if err:
	print errmsg, " ", err
else:
	print "\n".join(output)

session.logout()
sys.exit(0)
