Puppet::Type.newtype(:equallogic_volume_access_chap) do
  @doc = "Manage Equallogic Volume access chap."
  ensurable
  newparam(:name) do
    desc "The volume name. Valid characters are a-z, 1-9 & hyphen."
    isnamevar
    validate do |value|
      unless value =~ /^[a-zA-Z0-9-]{1,63}$/
        raise ArgumentError, "The %s is an invalid volume resource name." % value
      end
    end
  end

  newparam(:chap_user_name) do
    desc "The valid chap user name."
    validate do |value|
      unless value =~ /^[\w-]{1,63}$/
        raise ArgumentError, "The %s is an invalid chap user name." % value
      end
    end
  end

end
