Puppet::Type.newtype(:equallogic_volume_clone) do
  @doc = "Manage Equallogic Volume cloning."


  ensurable

  newparam(:volume_name) do
    desc "Existing volume name. Valid characters are a-z, 1-9, hyphen."
    validate do |value|
      unless value =~ /^[a-zA-Z0-9-]{1,63}$/
        raise ArgumentError, "The %s is an invalid volume resource name." % value
      end
    end
  end

  newparam(:name) do
    desc "The volume name. Valid characters are a-z, 1-9, hyphen."
    validate do |value|
      unless value =~ /^[a-zA-Z0-9-]{1,63}$/
        raise ArgumentError, "The %s is an invalid volume resource name." % value
      end
    end
  end

end
